/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Class.java to edit this template
 */
package com.qsoft.rs.sincoar.model;

import java.io.Serializable;
import java.math.BigInteger;
import javax.persistence.Column;
import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.JoinColumn;
import javax.persistence.JoinColumns;
import javax.persistence.ManyToOne;
import javax.persistence.NamedQueries;
import javax.persistence.NamedQuery;
import javax.persistence.Table;
import javax.xml.bind.annotation.XmlRootElement;

/**
 *
 * @author developer2
 */
@Entity
@Table(name="COMACO.TGENEMENULEVELDESC")
@XmlRootElement
@NamedQueries({
    @NamedQuery(name = "Tgenemenuleveldesc.findAll", query = "SELECT t FROM Tgenemenuleveldesc t"),
    @NamedQuery(name = "Tgenemenuleveldesc.findByMenucode", query = "SELECT t FROM Tgenemenuleveldesc t WHERE t.tgenemenuleveldescPK.menucode = :menucode"),
    @NamedQuery(name = "Tgenemenuleveldesc.findByLevelcode", query = "SELECT t FROM Tgenemenuleveldesc t WHERE t.tgenemenuleveldescPK.levelcode = :levelcode"),
    @NamedQuery(name = "Tgenemenuleveldesc.findByLanguagecode", query = "SELECT t FROM Tgenemenuleveldesc t WHERE t.tgenemenuleveldescPK.languagecode = :languagecode"),
    @NamedQuery(name = "Tgenemenuleveldesc.findByRecordversion", query = "SELECT t FROM Tgenemenuleveldesc t WHERE t.recordversion = :recordversion"),
    @NamedQuery(name = "Tgenemenuleveldesc.findByDescription", query = "SELECT t FROM Tgenemenuleveldesc t WHERE t.description = :description")})
public class Tgenemenuleveldesc implements Serializable {

    private static final long serialVersionUID = 1L;
    @EmbeddedId
    protected TgenemenuleveldescPK tgenemenuleveldescPK;
    @Column(name = "RECORDVERSION")
    private BigInteger recordversion;
    @Column(name = "DESCRIPTION")
    private String description;
    @JoinColumn(name = "LANGUAGECODE", referencedColumnName = "LANGUAGECODE", insertable = false, updatable = false)
    @ManyToOne(optional = false)
    private Tgenelanguage tgenelanguage;
    @JoinColumns({
        @JoinColumn(name = "MENUCODE", referencedColumnName = "MENUCODE", insertable = false, updatable = false),
        @JoinColumn(name = "LEVELCODE", referencedColumnName = "LEVELCODE", insertable = false, updatable = false)})
    @ManyToOne(optional = false)
    private Tgenemenulevel tgenemenulevel;

    public Tgenemenuleveldesc() {
    }

    public Tgenemenuleveldesc(TgenemenuleveldescPK tgenemenuleveldescPK) {
        this.tgenemenuleveldescPK = tgenemenuleveldescPK;
    }

    public Tgenemenuleveldesc(int menucode, int levelcode, String languagecode) {
        this.tgenemenuleveldescPK = new TgenemenuleveldescPK(menucode, levelcode, languagecode);
    }

    public TgenemenuleveldescPK getTgenemenuleveldescPK() {
        return tgenemenuleveldescPK;
    }

    public void setTgenemenuleveldescPK(TgenemenuleveldescPK tgenemenuleveldescPK) {
        this.tgenemenuleveldescPK = tgenemenuleveldescPK;
    }

    public BigInteger getRecordversion() {
        return recordversion;
    }

    public void setRecordversion(BigInteger recordversion) {
        this.recordversion = recordversion;
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String description) {
        this.description = description;
    }

    public Tgenelanguage getTgenelanguage() {
        return tgenelanguage;
    }

    public void setTgenelanguage(Tgenelanguage tgenelanguage) {
        this.tgenelanguage = tgenelanguage;
    }

    public Tgenemenulevel getTgenemenulevel() {
        return tgenemenulevel;
    }

    public void setTgenemenulevel(Tgenemenulevel tgenemenulevel) {
        this.tgenemenulevel = tgenemenulevel;
    }

    @Override
    public int hashCode() {
        int hash = 0;
        hash += (tgenemenuleveldescPK != null ? tgenemenuleveldescPK.hashCode() : 0);
        return hash;
    }

    @Override
    public boolean equals(Object object) {
        // TODO: Warning - this method won't work in the case the id fields are not set
        if (!(object instanceof Tgenemenuleveldesc)) {
            return false;
        }
        Tgenemenuleveldesc other = (Tgenemenuleveldesc) object;
        if ((this.tgenemenuleveldescPK == null && other.tgenemenuleveldescPK != null) || (this.tgenemenuleveldescPK != null && !this.tgenemenuleveldescPK.equals(other.tgenemenuleveldescPK))) {
            return false;
        }
        return true;
    }

    @Override
    public String toString() {
        return "com.qsoft.rs.sincoar.model.Tgenemenuleveldesc[ tgenemenuleveldescPK=" + tgenemenuleveldescPK + " ]";
    }
    
}
